package ru.langrafhomyak.db.jdbc_resources_manager

import java.lang.NullPointerException
import java.sql.ResultSet
import java.sql.SQLException
import java.sql.SQLType
import java.sql.Statement
import org.jetbrains.annotations.NotNull

internal abstract class ResultSetWrapper(@NotNull orig: ResultSet?) : ResultSet by (orig ?: throw NullPointerException("orig")) {
	@JvmField
	protected val _orig: ResultSet = (orig ?: throw NullPointerException("orig"))

	@Throws(SQLException::class)
	abstract override fun close()

	@Throws(SQLException::class)
	abstract override fun getStatement(): Statement?

	@Throws(SQLException::class)
	override fun updateObject(columnIndex: Int, x: Any?, targetSqlType: SQLType?, scaleOrLength: Int) {
		this._orig.updateObject(columnIndex, x, targetSqlType, scaleOrLength)
	}

	@Throws(SQLException::class)
	override fun updateObject(columnLabel: String?, x: Any?, targetSqlType: SQLType?, scaleOrLength: Int) {
		this._orig.updateObject(columnLabel, x, targetSqlType, scaleOrLength)
	}

	@Throws(SQLException::class)
	override fun updateObject(columnIndex: Int, x: Any?, targetSqlType: SQLType?) {
		this._orig.updateObject(columnIndex, x, targetSqlType)
	}

	@Throws(SQLException::class)
	override fun updateObject(columnLabel: String?, x: Any?, targetSqlType: SQLType?) {
		this._orig.updateObject(columnLabel, x, targetSqlType)
	}

	@Throws(SQLException::class)
	override fun getObject(columnIndex: Int, map: MutableMap<String?, Class<*>?>?): Any? {
		return this._orig.getObject(columnIndex, map)
	}

	@Throws(SQLException::class)
	override fun getObject(columnLabel: String?, map: MutableMap<String?, Class<*>?>?): Any? {
		return this._orig.getObject(columnLabel, map)
	}
}