@file:JvmName("_EntryPointsKt")

package ru.langrafhomyak.db.jdbc_resources_manager

import java.sql.Connection
import java.sql.PreparedStatement
import kotlin.contracts.InvocationKind
import kotlin.contracts.contract
import ru.landgrafhomyak.utility.highlevel_try_finally.safeAutoClose1

@Suppress("NOTHING_TO_INLINE")
@JvmName("prepareStatement")
public inline fun Connection.prepareStatement(ps: PreparedStatementsCompilationCache): PreparedStatement = ps.preparedStatementForConnection(this)

@JvmName("prepareStatement\$autoclose")
public inline fun <R> Connection.prepareStatement(ps: PreparedStatementsCompilationCache, preparedStatementScope: (ps: PreparedStatement) -> R): R {
	contract {
		callsInPlace(preparedStatementScope, InvocationKind.EXACTLY_ONCE)
	}
	val w = ps.preparedStatementForConnection(this)
	return safeAutoClose1(finally = w::close) { preparedStatementScope(w) }
}